const path = require('path')

module.exports.Helpers = {
    currnetDate: function() {
        return new Date().toISOString().
        replace(/T/, ' ').split(" ")[0]
    },
    currnetDateTime: function() {
        return new Date().toISOString().
        replace(/T/, ' ').
        replace(/\..+/, '')
    },
    isDict: function(v) {
        return typeof v === 'object' && v !== null && !(v instanceof Array) && !(v instanceof Date);
    },
    isEmptyDict: function(obj) {
        return Object.keys(obj).length === 0;
    },
    trimRight: function(v = "", charlist) {
        if (charlist == undefined) {
            charlist = "\s";
        }
        return v.replace(new RegExp(`${charlist} $`), "")
    },
    randomNumber: function(length) {
        return Math.floor(Math.pow(10, length - 1) + Math.random() * (Math.pow(10, length) - Math.pow(10, length - 1) - 1));
    },
    hashCode: function(length = 10) {
        var text = "";
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        for (var i = 0; i < length; i++)
            text += possible.charAt(Math.floor(Math.random() * possible.length));
        return text;
    },
    fileType: function(file, cb) {
        const filetypes = /jpg|jpeg|png|webp|mp4/
        const extname = filetypes.test(path.extname(file.originalname).toLowerCase())
        const mimetype = filetypes.test(file.mimetype);
        if (mimetype && extname) {
            return cb(null, true);
        } else {
            cb('Error: Images Only!');
        }
    },
    sendResponse: function(status, data, message, extra_param = {}) {
        let pack = {
            status: status,
            data: data,
            message: message
        }

        if (Object.keys(extra_param).length !== 0) {
            Object.assign(pack, extra_param)
        }

        return pack
    },
}