const { Helpers } = require('../controller/helpers');
const { DashboardModel } = require('../controller/index')
const { writeFile } = require('fs').promises
const moment = require('moment')
module.exports = {
    fetchData: async function(req, res) {
        let { fromdate, todate } = req.query
        let fetchAllValue, currentData, allFormData
        let result = {
                current: {},
                all: {},
                allCurrentcount: 0,
                allcount: 0
            },
            filter = {}
        currentData = await DashboardModel.fetchAllCurrentFormData()
        result['current'] = currentData
        if (currentData.length > 0) {
            fetchAllValue = currentData.map(value => { return value.num_rows })
            result['allCurrentcount'] = fetchAllValue.reduce((pv, cv) => { return pv + cv })
        }
        if (typeof fromdate !== "undefined" && typeof todate !== "undefined") {
            filter = { fromdate, todate }
        } else {
            filter = {}
        }
        allFormData = await DashboardModel.fetchAllFormData(filter)
        result['all'] = allFormData
        if (allFormData.length > 0) {
            fetchAllValue = allFormData.map(value => { return value.num_rows })
            result['allcount'] = fetchAllValue.reduce((pv, cv) => { return pv + cv })
        }
        return res.status(200).json(Helpers.sendResponse("success", result, `Dashboard Fetch Successfully`))
    },
    fetchFormData: async function(req, res) {
        let { fromdate, todate, fetchtype } = req.query
        var csv, file_name;
        if (typeof fromdate !== "undefined" && typeof todate !== "undefined") {
            filter = { fromdate, todate }
            csv = true
            file_name = `${process.env.CSV_UPLOAD_PATH}/${+new Date}_${fromdate}_${todate}.csv`
        } else if (typeof fetchtype !== "undefined") {
            csv = true
            file_name = `${process.env.CSV_UPLOAD_PATH}/${+new Date}_all.csv`
            filter = {}
        } else {
            filter = {}
            csv = false
        }
        const result = await DashboardModel.fetchData(filter)
        result.map(form => {
            let date = +new Date(form.form_date)
            if (!csv) {
                date = date
            } else {
                date = moment(date).format("DD/MM/YYYY h:m:s A")
            }
            form.form_date = date
        })
        if (csv) {
            if (typeof result[0] === "undefined") {
                return res.status(404).json(Helpers.sendResponse("fail", [], `Nothing to Show`))
            }
            const headers = Object.keys(result[0])
            if (result.length > 0) {
                csv = result.csv(headers)
                await writeFile(file_name, '\ufeff' + csv, 'utf8')
                file_name = file_name.split("/").slice(-1).join("")
                return res.status(200).json(Helpers.sendResponse("success", [{ url: `${process.env.CSV_UPLOAD_URI}${file_name}` }], `Converted To Csv`))
            } else {
                return res.status(404).json(Helpers.sendResponse("fail", [], `Nothing to Show`))
            }
        }

        return res.status(200).json(Helpers.sendResponse("success", result, `Dashboard Fetch Successfully`))

    }
}